/*  $Id: xml_writer_generic.h,v 1.3 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_xml_writer_generic
#define header_xml_writer_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/IOData/outputsource.h"

class CL_XMLWriter_Generic
{
//! Construction:
public:
	CL_XMLWriter_Generic() : output(0), delete_output(false), ref_count(0) { return; }

	~CL_XMLWriter_Generic() { if (delete_output) delete output; }

//! Attributes:
public:
	CL_OutputSource *output;
	
	bool delete_output;

//! Operations:
public:
	void add_ref() { ref_count++; }

	void release_ref() { if (--ref_count == 0) delete this; }

//! Implementation:
private:
	int ref_count;
};

#endif
