/*  $Id: pixel_format.cpp,v 1.3 2003/07/20 22:31:49 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Display/display_precomp.h"
#include "API/Display/pixel_format.h"

/////////////////////////////////////////////////////////////////////////////
// CL_PixelFormat construction:

CL_PixelFormat::CL_PixelFormat()
: colorkey_enabled(false), colorkey(0), red_mask(0), green_mask(0), blue_mask(0), alpha_mask(0), depth(0)
{
}

CL_PixelFormat::CL_PixelFormat(const CL_PixelFormat &copy)
{
	colorkey_enabled = copy.colorkey_enabled;
	colorkey = copy.colorkey;
	red_mask = copy.red_mask;
	green_mask = copy.green_mask;
	blue_mask = copy.blue_mask;
	alpha_mask = copy.alpha_mask;
	depth = copy.depth;
}

CL_PixelFormat::CL_PixelFormat(
	int depth,
	unsigned int red_mask,
	unsigned int green_mask,
	unsigned int blue_mask,
	unsigned int alpha_mask,
	bool use_colorkey,
	unsigned int colorkey)
: colorkey_enabled(use_colorkey), colorkey(colorkey), red_mask(red_mask), green_mask(green_mask), blue_mask(blue_mask), alpha_mask(alpha_mask), depth(depth)
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_PixelFormat attributes:

CL_PixelFormat CL_PixelFormat::rgba8888(32, 0xff000000, 0x00ff0000, 0x0000ff00, 0x000000ff);

CL_PixelFormat CL_PixelFormat::rgb888(24, 0xff0000, 0x00ff00, 0x0000ff, 0x000000);

CL_PixelFormat CL_PixelFormat::rgba4444(32, 0xf000, 0x0f00, 0x00f0, 0x000f);

CL_PixelFormat CL_PixelFormat::rgb555(16, 0x7c00, 0x03e0, 0x001f, 0x0000);

CL_PixelFormat CL_PixelFormat::rgb565(16, 0xf800, 0x07e0, 0x001f, 0x0000);
