/*  $Id: opengl_target.cpp,v 1.6 2003/08/30 13:11:04 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Display/display_precomp.h"
#include "opengl_target.h"
#ifdef WIN32
#include "WGL/display_window_opengl.h"
#else
#include "GLX/display_window_opengl.h"
#endif
#include "surface_target_opengl.h"

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget construction:


/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget attributes:


/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget operations:

CL_DisplayWindow_Generic *CL_OpenGLTarget::create_window()
{
	return new CL_DisplayWindow_OpenGL;
}

CL_Surface_Target *CL_OpenGLTarget::create_surface(
	CL_PixelBuffer *provider,
	bool delete_provider,
	CL_Surface::Hint hint)
{
	return new CL_Surface_Target_OpenGL(provider, delete_provider, hint);
}

bool CL_OpenGLTarget::enable_packer()
{
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLTarget implementation:
