/*  $Id: popupmenu_generic.h,v 1.18 2003/10/14 15:52:13 mbn Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_popupmenu_generic
#define header_popupmenu_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/GUI/popupmenu.h"

class CL_PopupMenu_Generic
{
//! Construction:
public:
	CL_PopupMenu_Generic(CL_PopupMenu *self);
	~CL_PopupMenu_Generic();

//! Attributes:
public:
	CL_PopupMenu *popupmenu;
	
//! Operations:
public:
	void popup(CL_Component *parent);

//! Signals:
public:
	CL_Signal_v1<const CL_MenuNode &> sig_selection_changed;
	CL_Signal_v0 sig_cancelled;
	
//! Slots:
private:
	CL_Slot slot_resize;
	CL_Slot slot_lost_focus;
	CL_Slot slot_mouse_down;

//! Callbacks:
private:
	void on_mouse_down(const CL_InputEvent &);
	void on_resize(int old_width, int old_height);
	void on_lost_focus();
};

#endif
