/*  $Id: treenode_generic.cpp,v 1.6 2003/07/20 22:23:22 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "precomp.h"
#include "../API/GUI/treenode.h"
#include "../API/GUI/treeview.h"
#include "treenode_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_TreeNode_Generic::CL_TreeNode_Generic(CL_TreeNode *self, CL_TreeView *root)
{
	treenode = self;
	
	this->root = root;
	component = NULL;
	delete_component = false;
	collapsed = false;
	selected = false;
	userdata = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

void CL_TreeNode_Generic::set_collapsed(bool new_collapsed)
{
	collapsed = new_collapsed;

	root->sig_selection_changed()(*treenode);
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_TreeNode_Generic::on_child_click(const CL_InputEvent &key)
{
	set_collapsed(!collapsed);
}
