/*  $Id: frame_boring.cpp,v 1.3 2003/07/20 22:23:22 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "API/Display/surface.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/GUIStyleBoring/frame_boring.h"
#include "API/GUIStyleBoring/stylemanager_boring.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_Frame_Boring::CL_Frame_Boring(
	CL_Frame *_frame,
	CL_StyleManager_Boring *style) 
:
	CL_ComponentStyle(_frame),
	frame(_frame),
	style(style)
{
	resources = style->get_resources();

	slot_paint = frame->sig_paint().connect(
		this, &CL_Frame_Boring::on_paint);
}

CL_Frame_Boring::~CL_Frame_Boring()
{
}

/////////////////////////////////////////////////////////////////////////////
// Callbacks:

void CL_Frame_Boring::on_paint()
{
	int width = frame->get_width();
	int height = frame->get_height();

	style->draw_box(0, 0, width, height, GUICOLOR_DARK_SHADE, GUICOLOR_BRIGHT_SHADE);

	if(frame->is_fill_enabled())
		style->fill_rect(1, 1, width - 1, height -1, GUICOLOR_MEDIUM_SHADE);
}
