/*  $Id: stylemanager_silver.cpp,v 1.3 2003/07/20 22:23:22 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "API/Display/display.h"
#include "API/Display/surface.h"
#include "API/Core/Resources/resource_manager.h"
#include "API/GUI/component_manager.h"
#include "API/guistylesilver.h"

// Construction:

CL_StyleManager_Silver::CL_StyleManager_Silver(CL_ResourceManager *resources)
: CL_StyleManager(resources)
{
}

CL_StyleManager_Silver::~CL_StyleManager_Silver()
{
}

void CL_StyleManager_Silver::draw_box(const CL_Rect &pos, const CL_Color &top_left, const CL_Color &bottom_right)
{
/*	int r, g, b, a;
	get_color(topleft, r, g, b, a);

	// Top line
	CL_Display::draw_line(x1, y1, x2 - 1, y1, CL_Color(r, g, b, a));

	// Left line
	CL_Display::draw_line(x1, y1 + 1, x1, y2 - 1, CL_Color(r, g, b, a));
	
	get_color(bottomright, r, g, b, a);

	// Bottom line
	CL_Display::draw_line(x1 + 1, y2 - 1, x2 - 1, y2 - 1, CL_Color(r, g, b, a));

	// Right line
	CL_Display::draw_line(x2 - 1, y1 + 1, x2 - 1, y2, CL_Color(r, g, b, a));
*/}

// Overridables:
void CL_StyleManager_Silver::connect_styles(
	const std::string &type,
	CL_Component *component)
{
	if (type == "label")
		component->set_style(new CL_Label_Silver((CL_Label *) component, this));

	else if (type == "button")
		component->set_style(new CL_Button_Silver((CL_Button *) component, this));

	else if (type == "frame")
		component->set_style(new CL_Frame_Silver((CL_Frame *) component, this));

	else if (type == "image")
		component->set_style(new CL_Image_Silver((CL_Image *) component, this));

	else if (type == "inputbox")
		component->set_style(new CL_InputBox_Silver((CL_InputBox *) component, this));

	else if (type == "scrollbar")
		component->set_style(new CL_ScrollBar_Silver((CL_ScrollBar *) component, this));

	else if (type == "progressbar")
		component->set_style(new CL_ProgressBar_Silver((CL_ProgressBar *) component, this));

	else if (type == "radiobutton")
		component->set_style(new CL_RadioButton_Silver((CL_RadioButton *) component, this));

	else if (type == "checkbox")
		component->set_style(new CL_CheckBox_Silver((CL_CheckBox *) component, this));

	else if (type == "listbox")
		component->set_style(new CL_ListBox_Silver((CL_ListBox *) component, this));

	else if (type == "window")
		component->set_style(new CL_Window_Silver((CL_Window *) component, this));
}
