/*  $Id: browse_client.cpp,v 1.7 2003/09/09 12:34:48 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include "API/Network/Browse/browse_client.h"
#include "browse_client_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseClient construction:

CL_BrowseClient::CL_BrowseClient(
	const std::string &app_id)
: impl(NULL)
{
	impl = new CL_BrowseClient_Generic(app_id);
}

CL_BrowseClient::~CL_BrowseClient()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseClient operations:

void CL_BrowseClient::connect(const CL_IPAddress &browse_master)
{
	impl->connect(browse_master);
}

void CL_BrowseClient::broadcast(const std::string &port)
{
	impl->broadcast(port);
}

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseClient signals:

CL_Signal_v2<const CL_IPAddress &, CL_NetPacket &> &CL_BrowseClient::sig_server_added()
{
	return impl->sig_server_added;
}

CL_Signal_v2<const CL_IPAddress &, CL_NetPacket &> &CL_BrowseClient::sig_server_updated()
{
	return impl->sig_server_updated;
}

CL_Signal_v1<const CL_IPAddress &> &CL_BrowseClient::sig_server_removed()
{
	return impl->sig_server_removed;
}

/////////////////////////////////////////////////////////////////////////////
// CL_BrowseClient implementation:
