
#ifndef header_propertybar
#define header_propertybar

#if _MSC_VER > 1000
#pragma once
#endif

#include <ClanLib/GUI/component.h>
#include <ClanLib/GUI/listbox.h>
#include <ClanLib/GUI/label.h>
#include <ClanLib/GUI/inputbox.h>

class MainFrame;
class Document;
class ComponentNode;

class PropertyBar : public CL_Component
{
//! Construction:
public:
	PropertyBar(MainFrame *mainframe);

	~PropertyBar();

//! Attributes:
public:
	Document &get_document();

	CL_ListBox listbox;
	CL_Label label;
	CL_InputBox input_number;
	CL_InputBox input_bool;
	CL_InputBox input_text;

//! Operations:
public:

//! Callbacks:
private:
	void on_node_options_changed(ComponentNode *node);
	void on_node_selection_changed(std::list<ComponentNode *> &selection); 
	void on_resize(int old_width, int old_height);
	void on_listbox_selection_changed();
	void on_input_change();

//! Implementation:
private:
	void select_none();
	
	CL_SlotContainer slots;

	MainFrame *mainframe;
	
	ComponentNode *selected_node;
};

#endif
