
#ifndef header_treebar
#define header_treebar

#if _MSC_VER > 1000
#pragma once
#endif

#include <map>
#include <ClanLib/GUI/component.h>
#include <ClanLib/GUI/treeview.h>

class MainFrame;
class Document;
class ComponentNode;
class CL_TreeView_Node;

class TreeBar : public CL_Component
{
//!Construction:
public:
	TreeBar(MainFrame *mainframe);

	~TreeBar();

//!Attributes:
public:
	Document &get_document();

	CL_TreeView tree;

//!Operations:
public:

//!Implementation:
private:
	typedef	std::map<ComponentNode *, CL_TreeNode *> t_NodeMap;
	t_NodeMap tree_nodes;

	void clear_nodes();

	void on_document_loaded();

	void on_resize(int old_width, int old_height);

	void on_tree_selection_changed(const CL_TreeNode &node);

	void on_node_added(ComponentNode *node);

	void on_node_removed(ComponentNode *node);

	void on_node_options_changed(ComponentNode *node);

	void on_node_type_changed(ComponentNode *node);

	void on_selection_changed(std::list<ComponentNode *> &selection);

	CL_SlotContainer slots;

	MainFrame *mainframe;
};

#endif
